package no.ntnu.idatt1002.demo.controller;

import java.text.NumberFormat;
import java.time.LocalDate;

import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.scene.control.DatePicker;
import javafx.scene.control.TextField;
import javafx.stage.Stage;
import no.ntnu.idatt1002.demo.data.Economics.Expense;
import no.ntnu.idatt1002.demo.data.Economics.Income;
import no.ntnu.idatt1002.demo.data.Economics.IncomeCategory;

public class AddIncomeController {

  Income newIncome = null;

  Income chosenIncome = null;
  @FXML
  private Button cancelBtn;

  @FXML
  private Button okBtn;

  @FXML
  private TextField dateField;

  @FXML
  private DatePicker datePicker;

  @FXML
  private TextField descriptionField;

  @FXML
  private TextField amountField;

  @FXML
  private ComboBox<IncomeCategory> categoryBox;

  @FXML
  private ComboBox<Boolean> recurringBox;

  @FXML
  public void initialize() {
    ObservableList<IncomeCategory> incomeCategories = FXCollections.observableArrayList(
        IncomeCategory.values());
    categoryBox.setItems(incomeCategories);
    categoryBox.setValue(IncomeCategory.GIFT);

    ObservableList<Boolean> recurring = FXCollections.observableArrayList(true, false);
    recurringBox.setItems(recurring);
    recurringBox.setValue(false);
  }

  public IncomeCategory getCategory() {
    return categoryBox.getValue();
  }

  public boolean isRecurring() {
    return recurringBox.getValue();//.equals("Yes");
  }

  public void setIncome(Income income) { //TODO NEED CANCEL BUTTON TO REMOVE THE CHANGES IF CANCEL IS PRESSED
    chosenIncome = new Income(income.getDescription(), income.getAmount(), income.isRecurring(), income.getCategory(), income.getDate());
    chosenIncome.descriptionProperty().bindBidirectional(income.descriptionProperty());
    chosenIncome.amountProperty().bindBidirectional(income.amountProperty());
    chosenIncome.recurringProperty().bindBidirectional(income.recurringProperty());
    //chosenExpense.().bindBidirectional(income.descriptionProperty());
    //chosenExpense.().bindBidirectional(income.descriptionProperty());
    descriptionField.textProperty().set(income.getDescription());
    amountField.textProperty().setValue(String.valueOf(income.getAmount()));
    recurringBox.setValue(income.isRecurring());

    //new SimpleStringProperty(datePicker.getValue().toString()).bindBidirectional(new SimpleStringProperty(income.getDate().toString()));
    //Bind this income's fields with the argument object's fields. If cancel is pressed - do nothing. If ok is pressed, bind the textfields with this expsense

    /*amountField.textProperty().bindBidirectional(income.amountProperty(), NumberFormat.getNumberInstance()); //TODO AMOUNT IS STORED WITH COMMA, WHICH IS NOT ALLOWED
    descriptionField.textProperty().bindBidirectional(income.descriptionProperty());
    //categoryBox.valueProperty().bindBidirectional(income.getCategory());
    recurringBox.valueProperty().bindBidirectional(income.recurringProperty());*/
  }

  @FXML
  public void pressOkBtn(ActionEvent event) {
    if (chosenIncome == null) {
      LocalDate date = datePicker.getValue();
      double amount = Double.parseDouble(amountField.getText());
      String description = descriptionField.getText();
      IncomeCategory category = getCategory();
      boolean recurring = isRecurring();
      newIncome = new Income(description, amount, recurring, category, date);
    }
    if (chosenIncome != null) {
      chosenIncome.setDescription((descriptionField.getText()));
      chosenIncome.setAmount(Double.parseDouble(amountField.getText()));
      chosenIncome.setRecurring(recurringBox.getValue());
    }

    final Node source = (Node) event.getSource();
    ((Stage) source.getScene().getWindow()).close();
  }

  @FXML
  public void pressCancelBtn(ActionEvent event) {
    final Node source = (Node) event.getSource();
    final Stage stage = (Stage) source.getScene().getWindow();

    stage.close();
  }

  public Income getNewIncome() {
    return this.newIncome;
  }
}